
-- function dynamicFarp(source_farp_name, dest_point)
--     local vars = {} 
--     vars.gpName = source_farp_name
--     vars.action = 'teleport' 
--     vars.point = mist.utils.makeVec3(dest_point)
--     mist.teleportToPoint(vars)
-- end

function teleportStatic(source_name, dest_point)
    local vars = {} 
    vars.gpName = source_name
    vars.action = 'teleport' 
    vars.point = mist.utils.makeVec3(dest_point)
    mist.teleportToPoint(vars)
end

function spawnFatCowFarpObjects(pt_x, pt_y)
    env.info('spawnFatCowFarpObjects called')
    local dest_point = mist.utils.makeVec3GL({x = pt_x, y = pt_y})
    trigger.action.smoke(dest_point, 2)

    trigger.action.outText('FatCow FARP deploying...get clear of the landing zone!', 20)
    timer.scheduleFunction(function()
        local fuel_point = {x = dest_point.x + 35, y = dest_point.y, z = dest_point.z}
        teleportStatic('DYN_FARP_FUEL', fuel_point)
        teleportStatic('DYN_FARP_TENT', fuel_point)
        
        local ammo_point = {x = dest_point.x - 35, y = dest_point.y, z = dest_point.z}
        teleportStatic('DYN_FARP_AMMO', ammo_point)
        
    end, nil, timer.getTime() + 235)
end


function spawnFatCow(fatcow_group_name, source_farp_name, dest_point)
    dest_point = mist.utils.makeVec2(dest_point)
    env.info('spawnFatCow called with ' .. source_farp_name)
    local approach_point = mist.getRandPointInCircle(dest_point, 1000, 900)
    trigger.action.smoke(mist.utils.makeVec3GL(approach_point), 1)
    
    
    local fatcow_group = Group.getByName(fatcow_group_name)
    if not fatcow_group then
        env.warning('FatCow group not found')
        return
    end

    teleportStatic(source_farp_name, dest_point)

    local airbasefarp = Airbase.getByName(source_farp_name)
    local airbase_pos = mist.utils.makeVec2(airbasefarp:getPoint())


    local script =  [[
        spawnFatCowFarpObjects(]] .. dest_point.x ..[[,]] .. dest_point.y .. [[)
        env.info('FatCow FARP deployment scheduled')
    ]]   


    local myscriptaction = {
        id = 'WrappedAction',
        params = {
          action = {
            id = 'Script',
            params = {
              command = script,  
    
            },
          },
        },
      }
    
    local script_string = [[local this_grp = ...
    this_grp:getController():setOption(AI.Option.Air.id.REACTION_ON_THREAT , AI.Option.Air.val.REACTION_ON_THREAT.EVADE_FIRE)
    this_grp:getController():setOption(AI.Option.Air.id.FLARE_USING , AI.Option.Air.val.FLARE_USING.WHEN_FLYING_NEAR_ENEMIES)]]

    local setOptions = {
    id = 'WrappedAction',
    params = {
        action = {
        id = 'Script',
        params = {
            command = script_string,

        },
        },
    },
    }

    local dropTroops = {
    id = 'WrappedAction',
    params = {
        action = {
        id = 'Script',
        params = {
            command = 'trigger.action.outText("Drop troops", 10)',  

        },
        },
    },
    }

    local group = Group.getByName("fatcow")
    local initial_point = group:getUnits()[1]:getPoint()
    local gp = mist.getGroupData("fatcow")
    --debugTable(gp)


    gp.route = {points = {}}
    gp.route.points[1] = mist.heli.buildWP(initial_point, initial, 'flyover', 0, 0, 'agl')
    gp.route.points[2] = mist.heli.buildWP(initial_point, initial, 'flyover', 100, 100, 'agl')
    gp.route.points[2].task = setOptions

    gp.route.points[3] = mist.heli.buildWP(approach_point, 'flyover', 100, 400, 'agl') 
    gp.route.points[4] = mist.heli.buildWP(approach_point, 'flyover', 20, 200, 'agl') 
    gp.route.points[5] = mist.heli.buildWP(dest_point, 'turning point', 10, 70, 'agl') 
    gp.route.points[5].task = myscriptaction
    gp.route.points[6] = {
        alt = 70,
        alt_type = "RADIO",
        speed = 10,
        x = airbase_pos.x,
        y = airbase_pos.y,
        helipadId = airbasefarp:getID(), 
        aerodromeId = airbasefarp:getID(),
        type = "Land",
        action = "Landing",
    } 


    gp.clone = true
    local new_group_data = mist.dynAdd(gp)
end

-- --make a CTLD logistics unit for spawning crates
    -- table.insert(ctld.logisticUnits, new_farp_gpname)

    -- --add a CTLD Beacon
    -- ctld.beaconCount = ctld.beaconCount + 1
    -- local _radioBeaconName = "FOB Beacon #" .. ctld.beaconCount
    -- local _radioBeaconDetails = ctld.createRadioBeacon(_args[1], _args[3], _args[2], _radioBeaconName, nil, true)
    -- ctld.fobBeacons[_name] = { vhf = _radioBeaconDetails.vhf, uhf = _radioBeaconDetails.uhf, fm = _radioBeaconDetails.fm }