trigger.action.outText('RotorOpsFatCow.lua loaded', 10)
--test in mp for mark.initiator (do marks work in mp?)
--troop proximity kills


local function tableHasKey(table,key)
    if table then
        return table[key] ~= nil
    else 
        env.warning("table parameter not provided")
        return nil
    end
    end



--RotorOps = {}
RotorOps.players = {} --by group name
RotorOps.troops_blue = {} --by group name

RotorOps.perks = {}
RotorOps.perks["fatcow"] = {
    perk_name='fatcow',
    display_name='FatCow FARP',
    cost=100,
    cooldown=30,
    max_per_player=1,
    max_per_mission=2,
    last_used=0,
    used=0,
}

RotorOps.perks["strike"] = {
    perk_name='strike',
    display_name='Instant Strike',
    cost=50,
    cooldown=10,
    max_per_player=5,
    max_per_mission=3,
    last_used=0,
    used=0,
}

function RotorOps.spendPoints(player_group_name, points)
    if RotorOps.players[player_group_name] then
        if RotorOps.players[player_group_name].points >= points then
            RotorOps.players[player_group_name].points = RotorOps.players[player_group_name].points - points
            return true
        end
    end
end

function RotorOps.scorePoints(player_group_name, points, message)
    if RotorOps.players[player_group_name] then
        RotorOps.players[player_group_name].points = RotorOps.players[player_group_name].points + points
        if message then
            trigger.action.outTextForGroup(RotorOps.players[player_group_name].groupId, message, 10)
        end
    end
end

function RotorOps.checkPoints(player_group_name)
    if RotorOps.players[player_group_name] then
        trigger.action.outTextForGroup(RotorOps.players[player_group_name].groupId, 'You have ' .. RotorOps.players[player_group_name].points .. ' points.', 10)
    end
end


function RotorOps.addPlayers()

    local function addPerkCommand(groupId, groupName, perk_name, path, vars)
        local perk = RotorOps.perks[perk_name]
        missionCommands.addCommandForGroup(groupId, 'Request '.. perk.display_name .. ' at ' .. vars.target, path , RotorOps.requestPerk, {player_group_name=groupName, perk_name=perk_name, target=vars.target})
    end

    for uName, uData in pairs(mist.DBs.humansByName) do
        env.info('Player ' .. uName .. ' found')
        --env.info(mist.utils.tableShow(uData, 'uData'))
        player_group = Group.getByName(uData.groupName)
        if player_group and RotorOps.players[uData.unitName] == nil then
            RotorOps.players[uData.groupName] = {
                points = 100,
                groupId = uData.groupId,
                groupName = uData.groupName,
            }
            missionCommands.addCommandForGroup(uData.groupId, 'Check points balance', nil , RotorOps.checkPoints, uData.groupName)
            addPerkCommand(uData.groupId, uData.groupName, 'fatcow', nil, {target='position'})
            addPerkCommand(uData.groupId, uData.groupName, 'fatcow', nil, {target='mark'})
            addPerkCommand(uData.groupId, uData.groupName, 'strike', nil, {target='mark'})
        end
        local player_unit = Unit.getByName(uData.unitName)
        if player_unit then

        end
    end
end

-- commandDB = {}
-- commandDB['root_menu'] = missionCommands.addSubMenu("ROTOROPS Perks")
-- local root_menu = commandDB['root_menu']
-- commandDB['request_fat_cow'] = missionCommands.addCommand("Request Fat Cow FARP at current position", root_menu , requestFatCow)



function teleportStatic(source_name, dest_point)
    local vars = {} 
    vars.gpName = source_name
    vars.action = 'teleport' 
    vars.point = mist.utils.makeVec3(dest_point)
    mist.teleportToPoint(vars)
end

function spawnFatCowFarpObjects(pt_x, pt_y, index)
    env.info('spawnFatCowFarpObjects called. Looking for static group names ending in ' .. index)
    local dest_point = mist.utils.makeVec3GL({x = pt_x, y = pt_y})
    trigger.action.smoke(dest_point, 2)

    trigger.action.outText('FatCow FARP deploying...get clear of the landing zone!', 20)
    timer.scheduleFunction(function()
        local fuel_point = {x = dest_point.x + 35, y = dest_point.y, z = dest_point.z}
        teleportStatic('DYN_FARP_FUEL ' .. index, fuel_point)
        teleportStatic('DYN_FARP_TENT ' .. index, fuel_point)
        
        local ammo_point = {x = dest_point.x - 35, y = dest_point.y, z = dest_point.z}
        teleportStatic('DYN_FARP_AMMO ' .. index, ammo_point)
        
    end, nil, timer.getTime() + 235)
end


function spawnFatCow(source_farp_name, dest_point, index)
    local fatcow_name = 'FATCOW'
    source_farp_name = source_farp_name .. ' ' .. index
    
    env.info('spawnFatCow called with ' .. source_farp_name)
    dest_point = mist.utils.makeVec2(dest_point)
    local approach_point = mist.getRandPointInCircle(dest_point, 1000, 900)
    --trigger.action.smoke(mist.utils.makeVec3GL(approach_point), 1)
    trigger.action.smoke(mist.utils.makeVec3GL(dest_point), 2)
    
    
    local fatcow_group = Group.getByName(fatcow_name)
    if not fatcow_group then
        env.warning('FatCow group not found')
        return
    end

    teleportStatic(source_farp_name, dest_point)

    local airbasefarp = Airbase.getByName(source_farp_name)
    local airbase_pos = mist.utils.makeVec2(airbasefarp:getPoint())


    local script =  [[
        spawnFatCowFarpObjects(]] .. dest_point.x ..[[,]] .. dest_point.y .. [[,]] .. index .. [[)
        env.info('FatCow FARP deployment scheduled')
    ]]   


    local myscriptaction = {
        id = 'WrappedAction',
        params = {
          action = {
            id = 'Script',
            params = {
              command = script,  
    
            },
          },
        },
      }
    
    local script_string = [[local this_grp = ...
    this_grp:getController():setOption(AI.Option.Air.id.REACTION_ON_THREAT , AI.Option.Air.val.REACTION_ON_THREAT.EVADE_FIRE)
    this_grp:getController():setOption(AI.Option.Air.id.FLARE_USING , AI.Option.Air.val.FLARE_USING.WHEN_FLYING_NEAR_ENEMIES)]]

    local setOptions = {
    id = 'WrappedAction',
    params = {
        action = {
        id = 'Script',
        params = {
            command = script_string,

        },
        },
    },
    }


    local group = Group.getByName(fatcow_name)
    local initial_point = group:getUnits()[1]:getPoint()
    local gp = mist.getGroupData(fatcow_name)
    --debugTable(gp)


    gp.route = {points = {}}
    gp.route.points[1] = mist.heli.buildWP(initial_point, initial, 'flyover', 0, 0, 'agl')
    gp.route.points[2] = mist.heli.buildWP(initial_point, initial, 'flyover', 100, 100, 'agl')
    gp.route.points[2].task = setOptions

    gp.route.points[3] = mist.heli.buildWP(approach_point, 'flyover', 100, 400, 'agl') 
    gp.route.points[4] = mist.heli.buildWP(approach_point, 'flyover', 20, 200, 'agl') 
    gp.route.points[5] = mist.heli.buildWP(dest_point, 'turning point', 10, 70, 'agl') 
    gp.route.points[5].task = myscriptaction
    gp.route.points[6] = {
        alt = 70,
        alt_type = "RADIO",
        speed = 10,
        x = airbase_pos.x,
        y = airbase_pos.y,
        helipadId = airbasefarp:getID(), 
        aerodromeId = airbasefarp:getID(),
        type = "Land",
        action = "Landing",
    } 


    gp.clone = true
    local new_group_data = mist.dynAdd(gp)
end

function RotorOps.requestStrike(args, dest_point)
    --explosion at dest_point after 10 seconds
    timer.scheduleFunction(function()
        trigger.action.explosion(dest_point, 1000)
    end, nil, timer.getTime() + 10)
end
    

function RotorOps.requestFatCow(args, dest_point)
    local player_group = Group.getByName(args.player_group_name)
    local index = RotorOps.perks.fatcow.used + 1
    spawnFatCow('FATCOW_FARP', dest_point, index)
end

function RotorOps.requestPerk(args)
    env.info('requestPerk called for ' .. args.perk_name)
    --env.info(mist.utils.tableShow(args, 'args'))
    local player_group = Group.getByName(args.player_group_name)
    local player_unit = player_group:getUnits()[1]
    local player_pos = player_unit:getPoint()

    --get the perk object
    local perk = RotorOps.perks[args.perk_name]

    --find the intended point
    local target_point = nil
    if args.target == 'position' then
        target_point = player_pos

    elseif args.target == 'mark' then
        local temp_mark = nil

        for _, mark in pairs(mist.DBs.markList) do
            env.info('mark: ' .. mist.utils.tableShow(mark, 'mark'))
            env.info('player group' .. mist.utils.tableShow(player_group, 'player_group'))
            env.info('player' .. mist.utils.tableShow(player_unit, 'player_unit'))
            local perk_name_matches = false

            --determine if mark name matches the perk name
            local mark_name = mark.text
            --remove whitespace and new line from mark name
            mark_name = mark_name:gsub("%s+", "")
            mark_name = mark_name:gsub("%n+", "")
            if mark_name == args.perk_name then
                perk_name_matches = true
            end
            
            if perk_name_matches then
                --if MULTIPLAYER (initiator property missing in single player)
                if mark.initiator then
                    --if mark is from player's group
                    if mark.initiator.id_ == player_unit.id_ then
                        target_point = mark.pos
                        if temp_mark then
                            --if there is already a mark from the player's group, use the most recent one
                            if mark.time > temp_mark.time then
                                temp_mark = mark
                            end
                        else
                            temp_mark = mark
                        end
                    end
                
                else --we assume single player
                    if temp_mark then
                        --if there is already a mark from the player's group, use the most recent one
                        if mark.time > temp_mark.time then
                            temp_mark = mark
                        end
                    else
                        temp_mark = mark
                    end
                end

            end
        end
        --env.info(mist.utils.tableShow(mist.DBs.markList, 'markList'))
        if temp_mark then
            target_point = temp_mark.pos
        end

    end

    -- check if the max used limit has been reached
    if perk.max_used ~= nil then
        if perk.used >= perk.max_used then
            env.info(args.player_group_name.. ' requested ' .. args.perk_name .. ' but max used reached')
            trigger.action.outTextForGroup(player_group:getID(), 'UNABLE. Used too many times in the mission.', 10)
            return
        end
    end

    --check if position requirements for action are met    
    if args.target == "mark" then
        if not target_point then
            env.info(args.player_group_name.. ' requested ' .. args.perk_name .. ' but no target was found')
            trigger.action.outTextForGroup(player_group:getID(), 'UNABLE. Add a mark called "' .. args.perk_name .. '" to the F10 map first', 10)
            return
        end
    end


    --check if cooldown is over in perks object
    if perk.cooldown > 0 then
        if perk.last_used + perk.cooldown > timer.getTime() then
            local time_remaining = perk.last_used + perk.cooldown - timer.getTime()
            --round time_remaining
            time_remaining = math.floor(time_remaining + 0.5)
            env.info(args.player_group_name.. ' tried to use ' .. args.perk_name .. ' but cooldown was not over')
            trigger.action.outTextForGroup(player_group:getID(), 'UNABLE. Wait for '.. time_remaining .. ' seconds.', 10)
            return
        end
    end



    --spend points
    if RotorOps.spendPoints(args.player_group_name, perk.cost)
        then
            env.info(args.player_group_name.. ' spent ' .. perk.cost .. ' points for ' .. args.perk_name)
        else
            env.info(args.player_group_name.. ' tried to spend ' .. perk.cost .. ' points for ' .. args.perk_name .. ' but did not have enough points')
            trigger.action.outTextForGroup(player_group:getID(), 'NEGATIVE. You have ' .. RotorOps.players[args.player_group_name].points .. ' points. (cost '.. perk.cost .. ')', 10)
            return
    end

    --perform the action
    if args.perk_name == RotorOps.perks.fatcow.perk_name then
        RotorOps.requestFatCow(args, target_point)
    elseif args.perk_name == RotorOps.perks.strike.perk_name then
        RotorOps.requestStrike(args, target_point)
    end

    --update last_used
    perk.last_used = timer.getTime()
    perk.used = perk.used + 1

    --message players with humansByName DB
    for _player_name, _player in pairs(mist.DBs.humansByName) do
        local position_string = ' at ' .. RotorOps.BRString(target_point, _player.point)
        if _player.groupName == args.player_group_name then --if the player is the one who requested the perk
            if args.target == 'position' then
                position_string = ' at your position'
            end
            -- send affirmative message to the the requesting player
            trigger.action.outTextForGroup(_player.groupId, 'AFFIRM. ' .. RotorOps.perks[args.perk_name].display_name .. position_string, 10)
        else
            -- send messages to all other players
            env.info(player_unit:getPlayerName() .. ' requested ' .. RotorOps.perks[args.perk_name].display_name .. position_string)
            trigger.action.outTextForGroup(_player.groupId, player_unit:getPlayerName() .. ' requested ' .. RotorOps.perks[args.perk_name].display_name .. position_string, 10)
        end
    end
    
end

function RotorOps.BRString(point_a, point_b)
    point_a = mist.utils.makeVec3(point_a, 0)
    point_b = mist.utils.makeVec3(point_b, 0)
    local vec = {x = point_a.x - point_b.x, y = point_a.y - point_b.y, z = point_a.z - point_b.z}
    local dir = mist.utils.getDir(vec, point_b)
    local dist = mist.utils.get2DDist(point_a, point_b)
    local bearing = mist.utils.round(mist.utils.toDegree(dir), 0)
    local range_nm = mist.utils.round(mist.utils.metersToNM(dist), 0)
    local range_ft = mist.utils.round(mist.utils.metersToFeet(dist), 0)
    local br_string = ''
    if range_nm > 0 then
        br_string = bearing .. '° ' .. range_nm .. 'nm'
    else
        br_string = bearing .. '° ' .. range_ft .. 'ft'
    end
    return br_string
end

function RotorOps.findUnitsInVolume(args)
    local foundUnits = {}
    local volS = {
     id = args.volume_type,
     params = {
       point = args.point,
       radius = args.radius
     }
    }
   
    local ifFound = function(foundObject, val)
        foundUnits[#foundUnits + 1] = foundObject    
    end
    world.searchObjects(Object.Category.UNIT, volS, ifFound)
    return foundUnits
end


local handle = {}
function handle:onEvent(e)
    --env.info('event id: ' .. e.id)
    --env.info(mist.utils.tableShow(e, 'all events'))
    
    --if enemy unit destroyed
    if e.id == world.event.S_EVENT_KILL then
        if e.initiator and e.target then
            if e.initiator:getCoalition() ~= e.target:getCoalition() then
                env.info('initiator groupname: ' .. e.initiator:getGroup():getName())
                --env.info('enemy unit destroyed')
                local initiator_group_name = e.initiator:getGroup():getName()

                -- if the initiator is ground unit/infantry
                if e.initiator:getDesc().category == Unit.Category.GROUND_UNIT then
                    local units_in_proximity = RotorOps.findUnitsInVolume({
                        volume_type = world.VolumeType.SPHERE,
                        point = e.initiator:getPoint(),
                        radius = 1852
                    })
                    for _, unit in pairs(units_in_proximity) do
                        env.info('unit in proximity'.. mist.utils.tableShow(unit, 'unit'))
                        local unit_group = unit:getGroup()
                        if unit_group then
                            env.info('unit group'.. mist.utils.tableShow(unit_group, 'Unit_group'))
                            local unit_group_name = unit_group:getName()
                            local player_group = RotorOps.players[unit_group_name]
                            if player_group then
                                RotorOps.scorePoints(unit_group_name, 5, 'Nearby allied ground unit kill: +5 points')
                            end
                        end
                    end
                end

                -- if a player's dropped troops killed enemy unit
                local dropped_troops = RotorOps.troops_blue[e.initiator:getGroup():getName()]
                if dropped_troops then
                    RotorOps.scorePoints(dropped_troops.player_group, 10, 'Your troops killed enemies! +10 points')
                end
            end
        end
    end
end
world.addEventHandler(handle)

function RotorOps.registerCtldCallbacks_NEW()
	ctld.addCallback(function(_args)
		local action = _args.action
		local unit = _args.unit
		local picked_troops = _args.onboard
		local dropped_troops = _args.unloaded
		env.info("ctld callback: ".. mist.utils.tableShow(_args)) 
        
        if dropped_troops then
            env.info('dropped troops: ' .. mist.utils.tableShow(dropped_troops))
            env.info('dropped troops group name: ' .. dropped_troops:getName())
            -- add dropped troops group to RotorOps.blue_troops
            RotorOps.troops_blue[dropped_troops:getName()] = {dropped_troops=dropped_troops:getName(), player_group=unit:getGroup():getName(), player_name=unit:getPlayerName(), player_unit=unit:getName(), qty=#dropped_troops:getUnits()}

        end

		  
		local playername = unit:getPlayerName()
		if playername then
			if action == "unload_troops_zone" or action == "dropped_troops" then
                RotorOps.scorePoints(unit:getGroup():getName(), 15, 'Troops dropped! +15 points')
			elseif action == "rearm" or action == "repair" then
				env.info('RotorOpsServer: adding points (rearm/repair) for ' ..playername)

			elseif action == "unpack" then
				env.info('RotorOpsServer: adding points (unpack) for ' ..playername)

			end
		end
	end)
end



RotorOps.addPlayers()
RotorOps.registerCtldCallbacks_NEW()

